#include "exchanger.h"

ListExchanger::ListExchanger() {
  this->set_bms( NULL_BMS );
  this->set_channel_type( BmsRegistArray::TYPE_WAV );
  this->clear_list();
}

ListExchanger::ListExchanger( BmsBms *bms, int channel_type ) {
  this->set_bms( bms );
  this->set_channel_type( channel_type );
  this->clear_list();
}

void ListExchanger::set_bms( BmsBms *bms ) {
  this->bms = bms;
}

void ListExchanger::set_channel_type( int channel_type ) {
  this->channel_type = channel_type;
}

void ListExchanger::clear_list() {
  this->before[0] = 0;
}

void ListExchanger::clear_and_set( BmsBms *bms, int channel_type ) {
  this->clear_list();
  this->set_bms( bms );
  this->set_channel_type( channel_type );
}


void ListExchanger::add_list( BmsWord before_word, BmsWord after_word ) {
  int before_int = before_word.get_int();
  for ( int i = 0; i < BmsWord::MAX; ++i ) {
    if ( this->before[i] == before_int || this->before[i] == 0 ) {
      if ( this->before[i] == 0 ) { this->before[i + 1] = 0; }
      this->before[i] = before_int;
      this->after[before_int] = after_word;
      break;
    }
  }
}

void ListExchanger::do_exchange() {
  BmsRegistArray *list_from, *list_to;
  bool (* channel_check)( BmsWord );

  switch ( this->channel_type ) {
  case BmsRegistArray::TYPE_BMP:
    list_to = bms->get_bmps();
    channel_check = BmsUtil::is_bmp_channel;
    break;
    
  case BmsRegistArray::TYPE_WAV:
  default:
    list_to = bms->get_wavs();
    channel_check = BmsUtil::is_wav_channel;
  }

  list_from = list_to->clone();
  for ( int i = 0; this->before[i] != 0; ++i ) {
    list_to->delete_at( this->before[i] );
  }
  for ( int i = 0; this->before[i] != 0; ++i ) {
    list_to->overwrite_in( this->after[this->before[i]], list_from->take_at( BmsWord( this->before[i] ) ) );
  }
  delete list_from;

  int max_position = this->bms->get_max_position();
  EACH_CHANNEL( this->bms->get_first_channel(), temp_channel ) {
    if ( (* channel_check)( temp_channel->get_channel_number() ) ) {
      for ( int i = 0; i <= max_position; ++i ) {
        if ( temp_channel->at( i ) != "00" ) {
          for ( int k = 0; this->before[k] != 0; ++k ) {
            if ( temp_channel->at( i ) == this->before[k] ) {
              temp_channel->overwrite( i, this->after[this->before[k]] );
              break;
            }
          }
        }
      }
    }
  }
}


int ListExchanger::get_count() {
  int i;
  for ( i = 0; this->before[i] != 0; ++i ) { }
  return i;
}
