#include "bmslsort.h"
#include <stdio.h>
#include <string.h>

DWORD  ListSet::get_ex_style()   { return WS_EX_CLIENTEDGE | WS_EX_ACCEPTFILES; }
DWORD  ListSet::get_style()      { return WS_VSCROLL | LBS_NOTIFY | LBS_DISABLENOSCROLL | LBS_NOINTEGRALHEIGHT | LBS_EXTENDEDSEL; }

bool ListSet::created() {
  for ( int i = 0; i < BmsWord::MAX; ++i ) {
    wsprintf( BMSLSORT::buf, "%c%c:%s", BmsWord( i ).get_msb(), BmsWord( i ).get_lsb(), this->bms_ary->at( BmsWord( i ) ) );
    this->delete_at( i );
    this->insert_at( i, BMSLSORT::buf );
  }

  this->override_wnd_proc();
  return true;
}

ListSet::ListSet( BmsBms *bms, int channel_type ) {
  this->channel_type = channel_type;
  this->set_bms( bms );
}

void ListSet::set_bms( BmsBms *bms ) {
  this->bms = bms;

  switch ( this->channel_type ) {
  case BmsRegistArray::TYPE_BMP:
    this->bms_ary = bms->get_bmps();
    break;

  case BmsRegistArray::TYPE_WAV:
  default:
    this->bms_ary = bms->get_wavs();
    break;
  }
  return;
}

BmsRegistArray *ListSet::get_bms_ary() {
  return this->bms_ary;
}

void ListSet::update_at( BmsWord index, char *str ) {
  this->bms_ary->overwrite( index, str );
  this->repaint_at( index );
}

int ListSet::repaint_all() {
  for ( int i = 0; i < BmsWord::MAX; ++i ) {
    this->repaint_at( BmsWord( i ) );
  }
  return BmsWord::MAX;
}

int ListSet::repaint_at( BmsWord index ) {
  wsprintf( BMSLSORT::buf, "%c%c:%s", index.get_msb(), index.get_lsb(), this->bms_ary->at( index ) );
  this->delete_at( index.get_int() );
  this->insert_at( index.get_int(), BMSLSORT::buf );
  return index.get_int();
}


LRESULT ListSet::wm_syskeydown_recved( int key, int info ) {
  info; // x}~̈

  switch ( key ) {
    //  case VK_LEFT: this->repaint_all(); return 0;
  case VK_UP:
  case VK_DOWN:
    if ( this->is_select( 0 ) ) { return 0; }
    {
      int move_dir = (key == VK_UP) ? (-1) : (1);
      int look_dir = -1 * move_dir;
      int start = (look_dir == 1) ? (1) : (BmsWord::MAX - 1);
      int end = BmsWord::MAX - start;

      // ړ悪ꍇ͈ړȂ
      if ( this->is_select( start ) ) { return 0; }

      BMSLSORT::exchanger->clear_and_set( this->bms, this->channel_type );

      int repaint_count = 0;
      int repaint_list[BmsWord::MAX] = { 0 };
      int select_count = 0;
      int select_list[BmsWord::MAX] = { 0 };

      bool on_select = false;
      int select_start = start + look_dir;
      for ( int i = start; i != end + look_dir; i += look_dir ) {
        if ( this->is_select( i ) ) {
          BMSLSORT::exchanger->add_list( BmsWord( i ), BmsWord( i + move_dir ) );
          repaint_list[repaint_count++] = i + move_dir;
          repaint_list[repaint_count] = 0;
          select_list[select_count++] = i + move_dir;
          select_list[select_count] = 0;
          if ( !(on_select) ) { on_select = true; select_start = i; }
          if ( i == end ) {
            BMSLSORT::exchanger->add_list( BmsWord( select_start + move_dir ), BmsWord( i ) );
            repaint_list[repaint_count++] = i;
            repaint_list[repaint_count] = 0;
          }
        }
        else {
          if ( on_select ) {
            on_select = false;
            BMSLSORT::exchanger->add_list( BmsWord( select_start + move_dir ), BmsWord( i + move_dir ) );
            repaint_list[repaint_count++] = i + move_dir;
            repaint_list[repaint_count] = 0;
          }
        }
      }
      BMSLSORT::exchanger->do_exchange();
      for ( int *p = repaint_list; *p != 0; ++p ) { this->repaint_at( *p ); }
      for ( int *p = select_list;  *p != 0; ++p ) { this->set_select( *p ); }

      return 0;
    }
  }
  return TTL_DEFAULT;
}


LRESULT ListSet::wm_key_down_recved( int key, int info ) {
  info; // x}~̈
  switch ( key ) {
  case VK_DELETE:
    {
      int tmp_cursor = this->get_current();
      for ( int i = 0; i < BmsWord::MAX; i++ ) {
        if ( this->is_select( i ) ) {
          this->bms_ary->delete_at( BmsWord( i ) );
          this->repaint_at( BmsWord( i ) );
        }
      }
      this->set_select( tmp_cursor );
    }
    return 0;

  case VK_RETURN:
    if ( this->channel_type != BmsRegistArray::TYPE_WAV ) { return 0; }
    char wav_filename[MAX_PATH];
    sprintf( wav_filename, "%s\\%s", BMSLSORT::now_bms_path_dir, this->bms_ary->at( this->get_current() ) );
    PlaySound( wav_filename, NULL, SND_FILENAME | SND_ASYNC | SND_NODEFAULT );
    return 0;

  }
  return TTL_DEFAULT;
}


LRESULT ListSet::wm_dropfiles_recved( HDROP h_drop ) {

  int insert_point = this->get_current();
  int drop_num = DragQueryFile( h_drop, 0xFFFFFFFF, NULL, 0 );

  for ( int i = 0; i < drop_num; ++i ) {
    // }ꏊ
    for ( ; insert_point < BmsWord::MAX; ++insert_point ) {
      if ( this->bms_ary->is_empty( BmsWord( insert_point ) ) ) { break; }
    }
    // ĂI
    if ( insert_point >= BmsWord::MAX ) { --insert_point; break; }

    // D&Dt@C̃pX菜
    char filename[MAX_PATH];
    DragQueryFile( h_drop, i, filename, sizeof( filename ) );
    BMSLSORT::edit_path( filename, false, false, true, true );
    this->update_at( insert_point, filename );
  }
  // ŌIĂ
  this->set_select( insert_point );
  this->set_forground();

  DragFinish( h_drop );
  return 0;
}


LRESULT ListSet::wnd_proc( UINT msg, WPARAM w_param, LPARAM l_param ) {
  LRESULT ret;
  switch ( msg ) {
  case WM_SYSKEYDOWN:
    ret = this->wm_syskeydown_recved( w_param, l_param );
    if ( ret != TTL_DEFAULT ) { return ret; } else { break; }

  case WM_KEYDOWN:
    ret = this->wm_key_down_recved( w_param, l_param );
    if ( ret != TTL_DEFAULT ) { return ret; } else { break; }

  case WM_DROPFILES:
    ret = this->wm_dropfiles_recved( (HDROP)w_param );
    if ( ret != TTL_DEFAULT ) { return ret; } else { break; }

  }
  return TtWindow::wnd_proc( msg, w_param, l_param );
}



bool ListSet::exchange_upper() {
  BMSLSORT::exchanger->clear_and_set( this->bms, this->channel_type );

  for ( int i = 1; i < BmsWord::MAX; ++i ) {
    if ( this->is_select( i ) ) {
      for ( int k = i + 1; k < BmsWord::MAX; ++k ) {
        if ( this->is_select( k ) ) {
          BMSLSORT::exchanger->add_list( BmsWord( i ), BmsWord( k ) );
          BMSLSORT::exchanger->add_list( BmsWord( k ), BmsWord( i ) );
          BMSLSORT::exchanger->do_exchange();
          this->repaint_at( i );
          this->repaint_at( k );
          this->set_select( i );
          this->set_select( k );
          return true;
        }
      }
      break;
    }
  }
  return false;
}


void ListSet::no_use_erase() {
  bool exist_list[BmsWord::MAX];
  this->make_exist_list( exist_list );

  for ( int i = 1; i < BmsWord::MAX; ++i ) {
    if ( !(exist_list[i]) && this->bms_ary->is_exist( BmsWord( i ) ) ) {
      this->bms_ary->delete_at( BmsWord( i ) );
      this->repaint_at( i );
    }
  }
}


void ListSet::fill() {
  bool exist_list[BmsWord::MAX];
  this->make_exist_list( exist_list );

  BMSLSORT::exchanger->clear_and_set( this->bms, this->channel_type );
  for ( int i = 1; i < BmsWord::MAX; ++i ) {
    if ( !(exist_list[i]) && this->bms_ary->is_empty( BmsWord( i ) ) ) {
      for ( int p = i; i < BmsWord::MAX; ++i ) {
        if ( exist_list[i] || this->bms_ary->is_exist( BmsWord( i ) ) ) {
          BMSLSORT::exchanger->add_list( BmsWord( i ), BmsWord( p ) );
          ++p;
        }
      }
    }
  }
  BMSLSORT::exchanger->do_exchange();
  this->repaint_all();
}


void ListSet::make_exist_list( bool exist_list[BmsWord::MAX] ) {
  for ( int i = 0; i < BmsWord::MAX; ++i ) { exist_list[i] = false; }

  bool (* channel_check)( BmsWord );
  switch ( this->channel_type ) {
  case BmsRegistArray::TYPE_BMP:
    channel_check = BmsUtil::is_bmp_channel;
    break;
  case BmsRegistArray::TYPE_WAV:
  default:
    channel_check = BmsUtil::is_wav_channel;
  }
  int max_position = this->bms->get_max_position();
  EACH_CHANNEL( bms->get_first_channel(), temp_channel ) {
    if ( (* channel_check)( temp_channel->get_channel_number() ) ) {
      for ( int i = 0; i <= max_position; ++i ) {
        if ( temp_channel->at( i ) != "00" ) { exist_list[temp_channel->at( i ).get_int()] = true; }
      }
    }
  }
}
